library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;
 entity Equation2 is
port(
    clk:in std_logic;
	v:in integer;
	y1:out integer;
	y2:out integer;
	u:out integer;
	flg:out integer
);
end Equation2;
architecture behavioral of Equation2 is
--constant
constant T:integer:=500;
constant r:integer:=1000000; 
constant Tc0:integer:=T/50;
constant N:integer:=100;
--signal
signal x10:integer:=1000;
signal x1,TTx10,TTx1:integer:=0;
signal Tx10,Tx1:integer:=0;
signal Tx20,Tx2:integer:=0;
signal x2,x20:integer:=0;
signal tmp:integer:=0;
signal ut:integer:=1;
signal sign_1:integer;
signal sign_x1:integer;
signal sign_x2:integer;
signal flag:integer:=1;
signal clk_1:std_logic:='1';
signal count:integer:=1;

begin 

process(clk)
begin
	
	if rising_edge(clk) then
		if count<N then
		count<=count+1;
		else
		clk_1<= not(clk_1);
		count<=1;
		end if;
	end if;
end process;
		


process(clk_1)
  begin 
	if rising_edge(clk_1) then
    TTx1<=TTx10+Tx20;
    Tx2<=Tx20-ut;
--		Tx1<=Tx10+x20;
--		x2<=x20+ut/T;
    end if;
--    x1<=Tx1/T;
    x1<=(TTx10+Tx20)/T/T;
    x2<=(Tx20-ut)/T;
	
end process;
process(clk_1)
	begin
	tmp<=x1-v;
end process;
    
Ut_compt:process(clk_1,x2,x1,tmp)
begin

if abs(Tc0*tmp+x2)>=r/Tc0 or abs(Tc0*tmp+x2*2)>=r/Tc0 then
	if tmp*x2>=0 then 
    ut<=r*sign_1;
    flag<=1;
    elsif abs(tmp)*r>=x2*x2/2+5*r*abs(x2)/Tc0/2+r/Tc0*r/Tc0/2 then
	ut<=r*sign_x1;
	flag<=2;
	elsif x2*x2+r*abs(x2)/Tc0>=2*r*abs(tmp) then 
    ut<=r*sign_x2;
    flag<=3;
    else
	ut<=(Tc0*x2*x2/r+3*abs(x2)+r/Tc0-2*abs(tmp)*Tc0)*sign_x2*Tc0/(2*abs(x2)*Tc0/r+1);
	flag<=4;
	end if;
else 
    ut<=(tmp*Tc0*Tc0+2*x2*Tc0);
    flag<=5;
end if;
	TTx10<=TTx1;
	Tx20<=Tx2;

end process Ut_compt;

sign:process(x1,x2,tmp)
	begin
	if tmp>0 then
	sign_x1<=1;
	elsif tmp<0 then
	sign_x1<=-1;
	else 
	sign_x1<=0;
	end if;
	
	if x2>0 then
	sign_x2<=1;
	elsif x2<0 then
	sign_x2<=-1;
	else 
	sign_x2<=0;
	end if;
	
	if Tc0*tmp+x2>0 then
	sign_1<=1;
	elsif Tc0*tmp+x2<0 then
	sign_1<=-1;
	else 
	sign_1<=0;
	end if;
end process sign;	

u<=ut;

y1<=x1;
y2<=x2*40;
flg<=flag;
end behavioral;
